//------------------------------------------------------------------------------
// Project Rabbit II unit Main
// Open Source FreeWare
// http://wtwsoft.narod.ru/build.htm
// original download from http://wtwsoft.narod.ru
//------------------------------------------------------------------------------
// .  .

unit BookLibrary;
interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, Config, StdCtrls, jpeg, ExtCtrls, ToolWin, ComCtrls;
const
 LibraryFileName : string = 'books.ini'; //        ,    

//      ,     .
//             TStringList,  
//   , , .         
//       ,      TStringList,   
//            
//    ,           
//        
 Name    = 0; //  
 Autor   = 1; //  
 Comment = 2; //   
 AddDate = 3; //     
 ReadDate= 4; //     
 FileSize= 5; //    
 DocType = 6; //  ,- , 
 FileName= 7; //       

 IndexCount = 7; //  
 IndexCount2 : byte = IndexCount; //     7,  .
//    ,  
 NamesStr : array [0..IndexCount] of string = ( 'Name','Autor','Comment','Add','Read','Size','Type','File name');
//    
 NamesWdh : array [0..IndexCount] of integer = ( 200,100,250,70,70,70,70,100);
//    ,  "",      
 NamesVsb : array [0..IndexCount] of boolean = ( true, true,true,false,false,true,true,false );
//           
 TestExistFiles : boolean = true;

type
//  - ,   IndexCount,    TStringList
  BooksRec = array [0..IndexCount] of TStringList;
//    
  TLibraryForm = class(TForm)
    StringGrid1: TStringGrid;
    procedure Button1Click(Sender: TObject);
    procedure StringGrid1SelectCell(Sender: TObject; ACol, ARow: Integer; var CanSelect: Boolean);
    procedure StringGrid1DblClick(Sender: TObject);

    procedure ExecuteLibrary;
    procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
    procedure StringGrid1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);

    procedure WindowMenuClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDeactivate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
  public

   Chois : integer;
   WindowToolButton : TToolButton;
  end;

//    
procedure ShowLibrary; //     
procedure CreateBooks; //    (,      ,          )
procedure AddBook( Name, Autor, Comment, FileName : string );overload;//    ,  ,   
procedure AddBook( Name, Autor, Comment, DocType, FileName : string );overload;// ,  
procedure DeleteBook( Num : integer ); //     
procedure SaveBooks; //    
procedure LoadBooks; //    

var
  LibraryForm: TLibraryForm; //   
  Books: BooksRec; //  
  Exist: array [0..IndexCount] of boolean; //  ,         

implementation
{$R *.dfm}
uses
 AddBookDialog, //        
 Main;
//     
procedure ShowLibrary;
begin
 if (LibraryForm = nil) then //      
  begin
   LibraryForm := TLibraryForm.Create(nil); //  
   with LibraryForm do //       , MainForm.ToolBar2
    begin
     WindowToolButton := TToolButton.Create(LibraryForm.Owner); //  
     WindowToolButton.Parent := MainForm.ToolBar2; //      
     WindowToolButton.Caption := ' Library '; //    
     WindowToolButton.OnClick := WindowMenuClick; //       
     ExecuteLibrary; //  
    end;
  end
 else LibraryForm.Show; //    ,     
 
 LibraryForm.WindowToolButton.Down := true; //  ,      
end;
//     
procedure CreateBooks;
var
  count : integer; //  
begin
 for count := 0 to IndexCount2 do //    
  if Books[count] = nil then //    
   Books[count] := TStringList.Create; //   
end;
//   
procedure AddBook( Name, Autor, Comment, FileName : string );
begin
 AddBook( Name, Autor, Comment,'',FileName ); //       
end;
//   
procedure AddBook( Name, Autor, Comment, DocType, FileName : string );
var
  sr: TSearchRec; //       
begin
 CreateBooks; //  ,      ()
 FindFirst(FileName, faAnyFile, sr); //       

//      ,       BookLibrary.Name   Name,   
 books[BookLibrary.Name].Add( Name ); //      
 books[BookLibrary.Autor].Add( Autor ); // 
 books[BookLibrary.Comment].Add( Comment );// 
 books[BookLibrary.AddDate].Add( DateToStr(Now)); //  ,  
 books[BookLibrary.ReadDate].Add(''); // ,       
 books[BookLibrary.FileSize].Add( IntToStr( sr.size )); //    
 books[BookLibrary.DocType].Add( DocType ); //  
 books[BookLibrary.FileName].Add( FileName ); //  
 SaveBooks; //  
 LoadBooks; // ,     
end;
//     Num
procedure DeleteBook( Num : integer );
var
  lcount : integer;
begin
 CreateBooks; // ,       ,   
 if num < Books[name].Count then exit; //           
 for lcount := 0 to IndexCount2 do //   - 
   Books[lcount].Delete( Num ); //         Num
 SaveBooks; //  
 LoadBooks; //  
end;
//    ,         TString   
//     
procedure SaveBooks;
var
 BooksFile : TStringList; //      = 
 BookCount, Count : integer; // 
begin
 BooksFile := TStringList.Create; //      
 CreateBooks; // ,      nil
 for BookCount:=0 to books[name].Count-1 do //           
  for Count := 0 to IndexCount2 do
   begin
    if books[Count].Count > BookCount then //       -  X*8    
     BooksFile.Add( books[Count][BookCount] ); //         
  end;
 booksfile.savetofile( StartDir + '/' + ConfigFolder + '/' + LibraryFileName ); //     
 booksfile.destroy; //   
end;
//   ,           ,          - 
procedure LoadBooks;
var
 BooksFile : TStringList; //      
 count, Index : integer; // 
begin
 BooksFile := TStringList.Create; //      
 if FileExists( StartDir + '/' + ConfigFolder + '/' + LibraryFileName ) then //     
   booksfile.loadfromfile( StartDir + '/' + ConfigFolder + '/' + LibraryFileName ); //      
 CreateBooks;//  

 for Count := 0 to IndexCount2 do Books[Count].Clear; //    ,         

 Count := 0; //   count / 8  

 if BooksFile.count >0 then //     
 repeat
  Index := 0; //    
  repeat
   //   ,      
   if count <= BooksFile.Count-1 then books[Index].add( BooksFile[count] )
                                 else books[Index].add( '' ); //    
   inc( count );
   inc( index );
  until ( index > 7 ); //     ,   
 until count >= BooksFile.count-1;
 booksfile.destroy; //   

 if TestExistFiles then //     
  begin
   for count := 0 to books[FileName].Count-1 do //           
    if FileExists(books[FileName][count]) then Exist[count] := true  //   
                     else Exist[count] := false; //      
  end;
end;
//      
procedure TLibraryForm.Button1Click(Sender: TObject);
begin
 AddBookDialog.AddBookForm.ShowModal; //   
end;
//      
procedure TLibraryForm.StringGrid1SelectCell(Sender: TObject; ACol, ARow: Integer; var CanSelect: Boolean);
begin
 Chois := ARow;
end;
//      ,    
procedure TLibraryForm.StringGrid1DblClick(Sender: TObject);
begin
 Main.MainForm.OpenFile( books[filename][Chois-1] ); //            
end;
//       
procedure TLibraryForm.ExecuteLibrary;
var
 count, c : integer; // 
begin
  LoadBooks; //  
  for Count := 0 to IndexCount2 do StringGrid1.Cols[count].Clear; //  

  StringGrid1.ColCount := IndexCount2+1; //       
  for count := 0 to indexcount2 do //       
   begin
    StringGrid1.Cols[count].Add(NamesStr[Count]); //       
    if NamesVsb[Count] then StringGrid1.ColWidths[count] :=  NamesWdh[Count] //      
                       else StringGrid1.ColWidths[count] := 0; //    ,   
   end;
  FormResize( LibraryForm ); //            
  StringGrid1.RowCount := Books[BookLibrary.Name].Count+1; //     ,    + 1    
  for Count := 0 to Books[BookLibrary.Name].Count-1 do //      
    for c := 0 to IndexCount2 do //   
      if Books[c].Count > Count then
       StringGrid1.Cols[c].Add( Books[c][count] ); //    ,     

  MainForm.StatusBar1.Panels[1].Text
   := 'books : ' + inttostr(books[BookLibrary.name].count); //       
end;
//   ,    .     
//          StringGrid
procedure TLibraryForm.StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
var
 s : string;
 i : integer;
begin
 if ARow = 0 then //      
  begin
  StringGrid1.Canvas.Font.Color := clBlack; //   
  StringGrid1.Canvas.Font.Style := [fsUnderline,fsBold]; //  -  
  StringGrid1.Canvas.Brush.Color := $00EEEbE2; //  ...
  StringGrid1.Canvas.FillRect(Rect); //    
  StringGrid1.Canvas.TextOut(Rect.Left+10, Rect.Top+1, StringGrid1.Cells[ACol,Arow] ); //    
  end
 else
  begin //    "" 
   StringGrid1.Canvas.Font.Color := clBlack; //   
   case ACol of //      
    0 : StringGrid1.Canvas.Font.Style := [fsBold]; //   - 
    1 : StringGrid1.Canvas.Font.Style := []; //  -  
    2 : StringGrid1.Canvas.Font.Style := []; // 
    5 : StringGrid1.Canvas.Font.Color := clBackGround; //   
   end;
  if not(Exist[ARow-1]) then StringGrid1.Canvas.Font.Color := clGray; //          
  if gdSelected in State then StringGrid1.Canvas.Brush.Color := clSkyBlue //          
                       else
                        begin
                            if ARow and 1 > 0 then StringGrid1.Canvas.Brush.Color := clWhite //      
                                              else StringGrid1.Canvas.Brush.Color := $00FFF9F0; //  
                        end;
  StringGrid1.Canvas.FillRect(Rect); //  
  s := ''; //       ,                      "..."
  if StringGrid1.Canvas.TextWidth( StringGrid1.Cells[ACol,Arow] ) > StringGrid1.ColWidths[ACol] then //         
   begin
   if StringGrid1.Cells[ACol,Arow] <> '' then //     (     )
    begin
     for i:=1 to length(StringGrid1.Cells[ACol,Arow]) do //               
      if StringGrid1.Canvas.TextWidth( s + '...    ' ) < StringGrid1.ColWidths[ACol] then
       s := s + StringGrid1.Cells[ACol,Arow][i]; //  
      s := s + '...'; //   
    end;
   end
   else
    s := StringGrid1.Cells[ACol,Arow];//         
  StringGrid1.Canvas.TextOut(Rect.Left+7, Rect.Top+1, s );//      
 end;
  StringGrid1.Canvas.Pen.Color := clSkyBlue;//     
  StringGrid1.Canvas.MoveTo(Rect.Right,1 );
  StringGrid1.Canvas.LineTo(Rect.Right,StringGrid1.RowHeights[0] );
end;
//      
procedure TLibraryForm.StringGrid1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key = VK_Delete then //   
  begin
   DeleteBook( Chois-1); //   
   ExecuteLibrary; //  
  end;
end;
//  ,       ,     ,
//      
procedure TLibraryForm.FormResize(Sender: TObject);
var
 count, size  : integer;
begin
  Size := 0;
  for count := 0 to IndexCount2 do //   
   inc( Size, StringGrid1.ColWidths[Count]); //   
  dec( Size,StringGrid1.ColWidths[2]); //    ,    
  StringGrid1.ColWidths[2] := Width - Size; //          
  if StringGrid1.ColWidths[2] < 50 then StringGrid1.ColWidths[2] := 70; //        70 
end;
//     ,    
procedure TLibraryForm.WindowMenuClick(Sender: TObject);
begin
 ShowLibrary;
end;
//  ,     2  
procedure TLibraryForm.FormClose(Sender: TObject;  var Action: TCloseAction);
begin
 WindowToolButton.Destroy;
 Action := caFree;
end;
//    ,      
procedure TLibraryForm.FormDeactivate(Sender: TObject);
begin
  if WindowToolButton <> nil then WindowToolButton.Down := false;
end;
//   ,     ...  ...
procedure TLibraryForm.FormDestroy(Sender: TObject);
begin
 LibraryForm := nil;
end;
end.
