unit log;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Config;

type
  TLogoForm = class(TForm)
    Image1: TImage;
    Label1: TLabel;
    RichEdit1: TRichEdit;
    Label4: TLabel;
    Panel1: TPanel;
    Label2: TLabel;
    Label3: TLabel;
  private
  public
  end;

  procedure AddToLog( Message: string );overload;
  procedure AddToLog( Source, Message: string );overload;
var
  LogoForm: TLogoForm;
  LogFile: String;
implementation
{$R *.dfm}
procedure AddToLog( Message: string );
var
 F : TextFile;
begin
 try
  if StartDir = '' then LogFile := 'log/rabbit2.log'
                   else LogFile := '/log/rabbit2.log';

  if not(FileExists(StartDir + LogFile)) then
   begin
    FileClose(FileCreate(StartDir + LogFile));
   end;
  AssignFile(F,StartDir + LogFile );
  Append(F);
  WriteLn(F, DateTimeToStr(Now) + ' GLOBAL' + #09 + Message );
  CloseFile(F);
  if (LogoForm <> nil) and (LogoForm.Label1 <> nil) then
   begin
    LogoForm.Label4.Caption := Message;
    LogoForm.Label4.Refresh;
   end;
 except
 end;
end;

procedure AddToLog( Source, Message: string );
var
 F : TextFile;
begin
 try
  if StartDir = '' then LogFile := 'log/rabbit2.log'
                   else LogFile := '/log/rabbit2.log';

  if not(FileExists(StartDir + LogFile)) then
   begin
    FileClose(FileCreate(StartDir + LogFile));
   end;
  AssignFile(F,StartDir + LogFile );
  Append(F);
  WriteLn(F, DateTimeToStr(Now) + ' ' + Source + #09 + Message );
  CloseFile(F);
  if (LogoForm <> nil) and (LogoForm.Label1 <> nil) then
   begin
    LogoForm.Label4.Caption := Message;
    LogoForm.Label4.Refresh;
   end;
 except
 end;
end;

end.
